﻿using System;
using System.Linq;
using System.Threading;

namespace Wisej.StockQuotesSample
{
	public static class QuoteServer
	{
		private static Thread _thread;

		public static event QuotesUpdatedEventHandler QuotesUpdated;

		static QuoteServer()
		{
			_thread = new Thread(Start);
			_thread.Start();
		}

		static void Start()
		{
			var rnd = new Random();
			var list = StockList.List;
			do
			{
				var changed = rnd.Next(list.Length);
				if (changed > 0)
				{
					var i = 0;
					var changedList = new string[changed];
					var changedQuotes = new double[changed];
					while (i < changed)
					{
						var stock = list[rnd.Next(list.Length)];
						if (changedList.Contains(stock))
							continue;

						changedList[i] = stock;
						changedQuotes[i] = rnd.NextDouble();
						i++;
					}

					QuotesUpdated?.Invoke(null, new QuotesUpdatedEventargs(changedList, changedQuotes));
				}

				Thread.Sleep(2000);

			} while (true);
		}
	}
}